﻿Type=Class
Version=3.6
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public gv As GameView
	Public pad As GamePad
	Private mainTimer As Timer
	Private fps As Float = 30
	Private lastTime As Long
	Private lblFPS As Label
	Private MyShip As Ship
	Public missileBitmap() As Bitmap
	Public missileRect(2) As Rect
	Public missiles As List
	Public shotSoundId = "shotgun.mp3" As String
End Sub

Public Sub Initialize (vGV As GameView, vPad As GamePad, vlblFPS As Label)
	GameUtils.Initialize
	gv = vGV
	pad = vPad
	lblFPS = vlblFPS
	mainTimer.Initialize("MainTimer", 15)
	missileBitmap = Array As Bitmap(LoadBitmap(File.DirAssets, "missile1.png"), _ 
		LoadBitmap(File.DirAssets, "missile2.png"))
	gv.BitmapsData.Add(CreateBackground)
	Dim bd As BitmapData
	MyShip.Initialize(bd , Me)
	gv.BitmapsData.Add(bd)
	missiles.Initialize
		
	'add the game pad 
	pad.Initialize(vGV.Panel.Parent)
	Dim length = 150, rightPadding = 20, leftPadding = 20, bottomPadding = 0 As Int
	pad.AddToGameView(gv, leftPadding, Main.height - bottomPadding - length, _
		Main.width - rightPadding - leftPadding, length)
	For Each s As String In Array As String(shotSoundId)
		gv.PrepareSoundEffect(File.DirAssets, s)
	Next
	StartGame
End Sub

Private Sub StartGame
	MyShip.ResetShip
End Sub


Public Sub StartTimer
	mainTimer.Enabled = True
End Sub

Public Sub StopTimer
	mainTimer.Enabled = False
End Sub

Private Sub mainTimer_Tick
	'calculate the frames per second
	fps = (1000 / Max(10, (DateTime.Now - lastTime)) + 20 * fps) / 21
	lblFPS.Text = NumberFormat(fps, 0, 0)
	lastTime = DateTime.Now
	
	
	'similar implementation for the missiles.
	Dim mis As Missile
	Dim i As Int
	Do While i < missiles.Size
		mis = missiles.Get(i)
		If mis.delete Then
			missiles.RemoveAt(i) 'remove missile
		Else
			mis.Tick
			i = i + 1
		End If
	Loop
	'call the ship tick method.
	MyShip.Tick
	'mark the GameView as "dirty". This will cause it to redraw itself.
	gv.Invalidate
End Sub

Public Sub PlaySound(sound As String, volume As Float)
	gv.PlaySoundEffect(File.DirAssets, sound, volume)
End Sub

'Create the stars background
Private Sub CreateBackground As BitmapData
	'The background is created manually with a bitmap and canvas.
	Dim cvs As Canvas = Main.CreateCanvas(Main.width, Main.height)
	cvs.DrawColor(Colors.Black)
	For i = 1 To 100
		cvs.DrawCircle(Rnd(0, Main.width), Rnd(0, Main.height), 2dip, Colors.White, True, 0)
	Next
	Dim bd As BitmapData
	bd.Bitmap = cvs.CreateBitmap
	cvs.Release
	bd.DestRect.Initialize(0, 0, Main.width, Main.height)
	Return bd
End Sub



