﻿Type=Class
Version=3.6
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'version: 1.10
Sub Class_Globals
	Private width, height As Int
	Private pnlRect As Rect
	Public const NONE = 0, LEFT = 1, RIGHT = 2, UP = 3, DOWN = 4 As Int
	Type joystick(x As Float, y As Float, zeroX As Float, zeroY As Float, color As Int, bd As BitmapData)
	Public jleft, jright As joystick
	Private radius As Int
	Private lftPanel, rightPanel As Panel
End Sub

Public Sub Initialize (parent As Panel)
	jleft.Initialize
	jleft.color = Colors.Red
	jright.Initialize
	jright.color = Colors.Blue
	lftPanel.Initialize("panel")
	rightPanel.Initialize("panel")
	'lftPanel.Color = Colors.Red
	'rightPanel.Color = Colors.Blue
	parent.AddView(lftPanel, 0, 0, 0, 0)
	parent.AddView(rightPanel, 0, 0, 0, 0)
End Sub

Public Sub AddToGameView(gv As GameView, vLeft As Int, vTop As Int, vWidth As Int, vHeight As Int)
	width = vWidth
	height = vHeight
	pnlRect.Initialize(vLeft, vTop, vWidth, vHeight)
	lftPanel.SetLayoutAnimated(0, 1, vLeft, vTop, vHeight, vHeight)
	rightPanel.SetLayoutAnimated(0, 1, vLeft + vWidth - vHeight, vTop, vHeight, vHeight)
	'add the two arrows
	Dim arrows As Bitmap = LoadBitmap(File.DirAssets, "arrows.png")
	Dim bd1, bd2 As BitmapData
	bd1.Bitmap = arrows
	bd1.DestRect.Initialize(vLeft, vTop, vLeft + vHeight, vTop + vHeight)
	bd2.Bitmap = arrows
	bd2.DestRect.Initialize(vLeft + vWidth - vHeight, vTop, vLeft + vWidth, vTop + vHeight)
	gv.BitmapsData.Add(bd1)
	gv.BitmapsData.Add(bd2)
	radius = height / 8
	jleft.bd.Bitmap = CreateBitmap(jleft.color)
	jleft.bd.DestRect.Initialize(0, 0, 0,0)
	gv.BitmapsData.Add(jleft.bd)	
	
	jright.bd.Bitmap = CreateBitmap(jright.color)
	jright.bd.DestRect.Initialize(0, 0, 0,0)
	gv.BitmapsData.Add(jright.bd)
	
	jleft.zeroX = height / 2
	jleft.zeroY = height / 2
	jright.zeroX = width - height / 2
	jright.zeroY = height / 2
	MoveJoystick(height / 2, height / 2, jleft)
	MoveJoystick(height / 2, height / 2, jright)
End Sub

Private Sub CreateBitmap(color As Int) As Bitmap
	Dim cvs As Canvas = Main.CreateCanvas(radius * 2, radius * 2)
	cvs.DrawCircle(radius, radius, radius, color, True, 0)
	Dim b As Bitmap = cvs.CreateBitmap
	cvs.Release
	Return b
End Sub

Private Sub Panel_Touch(Action As Int, X As Float, Y As Float)
	Dim j As joystick
	If Sender = lftPanel Then j = jleft Else j = jright
	If Action = lftPanel.ACTION_UP Then
		MoveJoystick(height / 2, height / 2, j)
	Else
		Dim gx As Float = Max (0, Min(X, height))
		Dim gy As Float = Max (0, Min(Y, height))
		MoveJoystick(gx, gy, j)
	End If
End Sub


Private Sub MoveJoystick(x As Float, y As Float, j As joystick)
	Dim valuex, valuey As Float
	valuex = x - height / 2
	valuey = y - height / 2
	If Abs(valuex) > Abs(valuey) Then valuey = 0 Else valuex = 0
	j.x = j.zeroX + valuex
	j.y = j.zeroY + valuey
	j.bd.DestRect.LEFT = j.x - radius + pnlRect.LEFT
	j.bd.DestRect.Top = j.y - radius + pnlRect.Top
	j.bd.DestRect.RIGHT = j.bd.DestRect.LEFT + 2 * radius
	j.bd.DestRect.Bottom = j.bd.DestRect.Top + 2 * radius
End Sub

Public Sub GetLeftValue As Int
	Return GetValue(jleft)
End Sub

Public Sub GetRightValue As Int
	Return GetValue(jright)
End Sub

Private Sub GetValue(j As joystick) As Int
	If Power(j.x - j.zeroX, 2) + Power(j.y - j.zeroY, 2) < Power(height / 6, 2) Then
		Return NONE
	Else If j.x < j.zeroX Then 
		Return LEFT
	Else If j.x > j.zeroX Then
		Return RIGHT
	Else If j.y > j.zeroY Then
		Return DOWN
	Else If j.y < j.zeroY Then
		Return UP
	End If
	Return NONE
End Sub