﻿Type=Class
Version=3.6
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private animator As SpriteAnimator
	Private shipBd As BitmapData
	Private game As GameManager
	Private shipRect As Rect
	Private ticks, lastFire, fireInterval = 5 As Int
	Private missileSpeed = 8 * GameUtils.scale As Int
	Public state As Int
End Sub

Public Sub Initialize (vBD As BitmapData, vGame As GameManager)
	animator.Initialize
	shipBd = vBD
	shipBd.Bitmap = LoadBitmap(File.DirAssets, "ship.png")
	animator.width = 30 * GameUtils.scale 'set the sprite width and height
	animator.height = 45 * GameUtils.scale
	Dim x, y As Int
	x = Main.width / 2  - animator.width / 2 'start in the middle of the screen
	y = Main.height - animator.height - 30
	shipBd.DestRect.Initialize(x, y , x + animator.width, y + animator.height)
	game = vGame
End Sub

Public Sub ResetShip
	ticks = 0
	lastFire = -100
	animator.AnimationInterval = 1
	'note that the ship is drawn from a single frame.
	'shipRect is never initialized so GameView draws the complete bitmap.
	animator.SetFrames(shipBd, Array As Rect(shipRect), Array As Bitmap(shipBd.Bitmap))
End Sub

Public Sub Tick
	ticks = ticks + 1
	'check the left joystick and change the rotation and speed
	Select game.pad.GetLeftValue
		Case game.pad.LEFT
			shipBd.Rotate = shipBd.Rotate - 3
		Case game.pad.RIGHT
			shipBd.Rotate = shipBd.Rotate + 3
	End Select
		
	If ticks - lastFire > fireInterval Then
		lastFire = ticks
		'check whether the player is shooting
		Select game.pad.GetRightValue
			Case game.pad.UP
				ShootMissile(shipBd.Rotate)
			Case game.pad.RIGHT
				ShootMissile(shipBd.Rotate + 90)
			Case game.pad.DOWN
				ShootMissile(shipBd.Rotate + 180)
			Case game.pad.LEFT
				ShootMissile(shipBd.Rotate + 270)
		End Select
	End If
	animator.Tick(shipBd) 'move the ship
End Sub



Private Sub ShootMissile (offset As Int)
	game.PlaySound(game.shotSoundId, 0.3)
	'create a new Missile and add it to GameView and GameManager.
	Dim msl As Missile
	Dim missileAnimator As SpriteAnimator
	missileAnimator.Initialize
	Dim mbd As BitmapData
	missileAnimator.SetFrames(mbd, game.missileRect, game.missileBitmap)
	mbd.Rotate = offset
	msl.Initialize(mbd, missileAnimator, game)
	Dim x, y As Int
	x = shipBd.DestRect.CenterX
	y = shipBd.DestRect.CenterY
	mbd.DestRect.Initialize(x, y, x + missileAnimator.width, y + missileAnimator.height)
	missileAnimator.vx = missileSpeed * SinD(offset)
	missileAnimator.vy = -missileSpeed * CosD(offset)
	game.gv.BitmapsData.Add(mbd)
	game.missiles.Add(msl)
End Sub